;
; SSFEXE.COM : SATURN File Executor
;
; Copyright (C) 1997 ohD
; for MS-DOS version
;
		P186
		IDEAL
		DOSSEG
		MODEL	TINY
		CODESEG
		ORG	0100H

;
; vOJn
;
START:
		CLD
		MOV	AX,CS
		MOV	DS,AX
		MOV	ES,AX
		MOV	SS,AX
		XOR	SP,SP
;
		MOV	DX,offset TITLE_MSG
		CALL	PRINT
		CALL	MEMORY
		JC	@@MEMERR
		CALL	GET_ENV
		CALL	GET_OPT
		JC	@@USAGE
;
		ifdef	DEBUG
		CALL	INFO
		endif
		CALL	OPEN
		JC	@@FILEERR
		CALL	CONNECT
		JC	@@ERROR
		CALL	SEND_INFO
		JC	@@ERROR
		CALL	SEND_MAIN
		JC	@@ERROR
		CALL	SEND_SUM
		JC	@@ERROR
		CALL	CLOSE
;
		MOV	AX,4C00H
		INT	21H

;
; UsageG[
;
@@USAGE:
		MOV	DX,offset USAGE_MSG
		JMP	ERROR

;
; s
;
@@MEMERR:
		MOV	DX,offset MEMORY_MSG
		JMP	ERROR

;
; t@CG[
;
@@FILEERR:
		MOV	DX,offset FILEERR_MSG
		JMP	ERROR

;
; ʐMLZA`FbNTG[
;
@@ERROR:
		MOV	DX,offset ERROR_MSG
		JMP	ERROR

;-[  ]------------------------------------------------------------------

;
; `FbN
;
MEMORY:
		MOV	AX,[ES:0002H]
		MOV	BX,CS
		ADD	BX,2000H
		SUB	AX,BX
		RET

;
; ϐ "PORT" 擾
;
GET_ENV:
		MOV	AX,[ES:002Ch]
		MOV	ES,AX
		XOR	DI,DI
; ϐ[v
@@LOOP:
		TEST	[byte ES:DI],0FFh
		JZ	@@EXIT
; "PORT"Ɣr
		MOV	SI,offset PORT_ENV
@@CMP_LP:
		LODSB
		OR	AL,AL
		JZ	@@CMP_END
		CMP	AL,[ES:DI]
		JNZ	@@NEXT
		INC	DI
		JMP	@@CMP_LP
; "=" 
@@CMP_END:
		CMP	[byte ES:DI],'='
		JNZ	@@NEXT
		INC	DI
; Pǂݎ
		MOV	AL,[ES:DI]
		CMP	AL,'0'
		JC	@@ERROR
		CMP	AL,'4'
		JNC	@@ERROR
		SUB	AL,'0'
		MOV	[PORT],AL
		JMP	@@EXIT
; ̊ϐ
@@NEXT:
		TEST	[byte ES:DI],0FFh
		JZ	@@NEXT_OK
		INC	DI
		JMP	@@NEXT
@@NEXT_OK:
		INC	DI
		JMP	@@LOOP
; G[
@@ERROR:
		MOV	DX,offset ENVERR_MSG
		CALL	ERROR
; ׂďI
@@EXIT:
		RET

;
; R}hCp[^擾
;
; RESULT: CY
;
GET_OPT:
		MOV	AX,CS
		MOV	ES,AX
		MOV	SI,0080H
		XOR	DL,DL
; R}hC邩
		LODSB
		OR	AL,AL
		JZ	@@EXIT
		INC	SI
; P[v
@@LOOP:
		CALL	SKIP_SPC
		JC	@@EXIT
; IvV
		CMP	AL,'-'
		JZ	@@OPTION
		CMP	AL,'/'
		JZ	@@OPTION
; t@C
		MOV	DI,offset FILENAME
		STOSB
@@FLOOP:
		LODSB
		OR	AL,AL
		JZ	@@FEND
		CMP	AL,20H
		JZ	@@FEND
		JC	@@FEND
		STOSB
		JMP	@@FLOOP
; t@CI
@@FEND:
		XOR	AL,AL
		STOSB
		INC	DL
		DEC	SI
		JMP	@@LOOP
; I
@@EXIT:
		CMP	DL,01H
		JZ	@@RET
; G[
@@ERROR:
		STC
@@RET:
		RET

; IvV
@@OPTION:
		CALL	SKIP_SPC
		JC	@@RET
; IvV`FbN
		OR	AL,20H
		CMP	AL,'p'
		JZ	@@PORT
		CMP	AL,'k'
		JZ	@@KEY
		CMP	AL,'l'
		JZ	@@ADRS
		JMP	@@ERROR
; 'p'
@@PORT:
		LODSB
		CMP	AL,'0'
		JC	@@RET
		CMP	AL,'4'
		JNC	@@ERROR
		SUB	AL,'0'
		MOV	[PORT],AL
		JMP	@@LOOP
; 'k'
@@KEY:
		MOV	AL,01H
		MOV	[WAIT_KEY],AL
		JMP	@@LOOP
; 'l'
@@ADRS:
		XOR	BX,BX
		XOR	CX,CX
@@ADRS_LP:
		LODSB
		OR	AL,AL
		JZ	@@ADRS_END
		CMP	AL,20H
		JZ	@@ADRS_END
		CMP	AL,09H
		JZ	@@ADRS_END
; 荞
		CMP	AL,'0'
		JC	@@ERROR
		CMP	AL,'9'+1
		JC	@@DEC
		OR	AL,20H
		CMP	AL,'a'
		JC	@@ERROR
		CMP	AL,'f'+1
		JNC	@@ERROR
		SUB	AL,07H
@@DEC:
		SUB	AL,30H
; BX:CX[e[g
		SHL	BX,4
		MOV	AH,CH
		SHL	CX,4
		SHR	AH,4
		OR	BL,AH
; AL  OR
		OR	CL,AL
; 
		JMP	@@ADRS_LP
; AhXI
@@ADRS_END:
		MOV	[ADRS],CX
		MOV	[ADRS+2],BX
		JMP	@@LOOP

;
; Xy[XE^uXLbv
;
; RESULT: CY
;
SKIP_SPC:
@@LOOP:
		LODSB
		OR	AL,AL
		JZ	@@ERROR
		CMP	AL,09H
		JZ	@@LOOP
		CMP	AL,20H
		JZ	@@LOOP
		JC	@@ERROR
@@OK:
		CLC
		RET
@@ERROR:
		STC
		RET

		ifdef	DEBUG
;
; ݒ󋵕\
;
INFO:
		MOV	AX,DS
		MOV	ES,AX
;
		MOV	DX,offset FILE_MSG
		CALL	PRINT
		MOV	SI,offset FILENAME
@@FILE:
		LODSB
		OR	AL,AL
		JZ	@@FILE_END
		MOV	DL,AL
		MOV	AH,02H
		INT	21H
		JMP	@@FILE
@@FILE_END:
		MOV	DL,13
		MOV	AH,02H
		INT	21H
		MOV	DL,10
		MOV	AH,02H
		INT	21H
;
		MOV	SI,offset PORT_MSG
		MOV	AL,[PORT]
		ADD	AL,30H
		MOV	[SI+15],AL
		MOV	DX,SI
		CALL	PRINT
;
		MOV	DI,offset ADRS_MSG
		ADD	DI,14
		MOV	AX,[ADRS+2]
		CALL	HEX4SET
		MOV	AX,[ADRS]
		CALL	HEX4SET
		MOV	DX,offset ADRS_MSG
		CALL	PRINT
		RET

;
; PUiSZbg
;
HEX4SET:
		PUSH	AX
		XCHG	AH,AL
		CALL	HEX2SET
		POP	AX

;
; PUiQZbg
;
HEX2SET:
		PUSH	AX
		SHR	AL,4
		CALL	HEX1SET
		POP	AX

;
; PUiPZbg
;
HEX1SET:
		AND	AL,0FH
		ADD	AL,30H
		CMP	AL,3AH
		JC	@@OK
		ADD	AL,07H
@@OK:
		STOSB
		RET
		endif

;-[ t@C֘A ]-----------------------------------------------------------

;
; t@CI[v
;
OPEN:
		MOV	DX,offset FILENAME
		MOV	AX,3D00H
		INT	21H
		JC	@@ERROR
		MOV	[FILEH],AX
;
		MOV	BX,AX
		MOV	AX,4202H
		XOR	CX,CX
		XOR	DX,DX
		INT	21H
		JC	@@ERROR
		MOV	[FILELEN+2],DX
		MOV	[FILELEN],AX
;
		MOV	BX,[FILEH]
		MOV	AX,4200H
		XOR	CX,CX
		XOR	DX,DX
		INT	21H
@@ERROR:
		RET

;
; t@CN[Y
;
CLOSE:
		MOV	BX,[FILEH]
		MOV	AH,3EH
		INT	21H
		RET

;-[ Q[N ]-------------------------------------------------------

;
; DXݒ
;
DX_PORT:
		MOV	DH,03H
		MOV	DL,[CS:PORT]
		SHL	DL,4
		RET

;
; ڑmF
;
; RESULT: CY
;
CONNECT:
		MOV	DX,offset CONNECT_MSG
		CALL	PRINT
; |[gݒ
		CALL	DX_PORT
; [v
@@LOOP:
		MOV	AL,'W'
		CALL	SEND_RECE
		JC	@@CANCEL
		CMP	AL,'R'
		JNZ	@@LOOP
;
		MOV	AL,'B'
		CALL	SEND_RECE
		JC	@@CANCEL
		CMP	AL,'W'
		JNZ	@@LOOP
;
		MOV	AL,'X'
		CALL	SEND_RECE
@@CANCEL:
		RET

;
; 񑗐M
;
SEND_INFO:
		MOV	BX,[ADRS+2]
		MOV	AX,[ADRS]
		CALL	SEND_LONG
		JC	@@EXIT
;
		MOV	BX,[FILELEN+2]
		MOV	AX,[FILELEN]
		CALL	SEND_LONG
@@EXIT:
		RET

;
; CM
;
SEND_MAIN:
		MOV	DX,offset DATA_MSG
		CALL	PRINT
		XOR	AX,AX
		MOV	[CHKSUM],AX
; O[v[v
@@GROUP_LP:
		MOV	CX,[FILELEN]
		MOV	AX,[FILELEN+2]
		OR	AX,AX
		JZ	@@GROUP
		DEC	AX
		MOV	[FILELEN+2],AX
		XOR	CX,CX
; O[v CX=TCY
@@GROUP:
		PUSH	DS
		PUSH	CX
; ǂݍ݂P
		CMP	CX,8000H
		JC	@@READ1
		MOV	CX,8000H
@@READ1:
		MOV	BX,[FILEH]
		MOV	AX,CS
		ADD	AX,1000H
		MOV	DS,AX
		XOR	DX,DX
		MOV	AH,3FH
		INT	21H
; ǂݍ݂Q
		POP	CX
		PUSH	CX
		SUB	CX,8000H
		JC	@@READ_END
		JZ	@@READ_END
@@READ2:
		MOV	BX,[CS:FILEH]
		MOV	AX,CS
		ADD	AX,1000H
		MOV	DS,AX
		MOV	DX,8000H
		MOV	AH,3FH
		INT	21H
; ǂݍݏI
@@READ_END:
		POP	CX
		CALL	DX_PORT
		MOV	AX,CS
		ADD	AX,1000H
		MOV	DS,AX
		XOR	SI,SI
		MOV	BX,[CS:CHKSUM]
		XOR	AH,AH
; M[v
@@LOOP:
		LODSB
		MOV	DI,AX
		CALL	SEND_RECE
		JC	@@CANCEL
		CMP	AX,DI
		JNZ	@@CANCEL
		ADD	BX,AX
		LOOP	@@LOOP
		MOV	[CS:CHKSUM],BX
; ̃O[v
		POP	DS
		TEST	[word FILELEN+2],0FFFFh
		JNZ	@@GROUP_LP
		CLC
		RET
; LZ
@@CANCEL:
		POP	DS
		STC
		RET

;
; `FbNTƍ
;
SEND_SUM:
		TEST	[byte WAIT_KEY],01h
		JZ	@@SEND
; L[҂
		MOV	DX,offset PAUSE_MSG
		CALL	PRINT
		MOV	AH,08H
		INT	21H
@@SEND:
		CALL	DX_PORT
		MOV	AX,[CHKSUM]
		AND	AX,0FFFH
		CALL	SEND_WORD
		MOV	BX,[CHKSUM]
		AND	AX,0F00H
		AND	BX,0F00H
		CMP	AX,BX
		JNZ	@@ERROR
		CLC
		RET
@@ERROR:
		STC
		RET

;-[ Q[Nh^n ]------------------------------------------------------

;
; PoCgó
;
; PARAM.: AL	o̓f[^
;	  DX	h^n|[g
; RESULT: AL	ʃf[^
;	  CY	LZtO
;
SEND_RECE:
		PUSH	CX
; o
		OUT	DX,AL
; atrx
		XOR	CX,CX
		ADD	DX,2
; atrx҂
@@BUSY:
		IN	AL,DX
		SHR	AL,01H
		JNC	@@OK
; atrx
		INC	CL
		AND	CL,1FH
		JNZ	@@BUSY
; RQɂPLZ`FbN
		CALL	CANCEL_CHK
		JNC	@@BUSY
; LZ
		POP	CX
		STC
		RET
; MďI
@@OK:
		SUB	DX,2
		IN	AL,DX
		POP	CX
		CLC
		RET

;
; LZ`FbN
;
; RESULT: CY
;
CANCEL_CHK:
		PUSH	AX
		PUSH	DX
		MOV	DL,0FFH
		MOV	AH,06H
		INT	21H
		JZ	@@EXIT
; ESC`FbN
		CMP	AL,1BH
		JNZ	@@EXIT
; LZI
		POP	DX
		POP	AX
		STC
		RET
; m[}I
@@EXIT:
		POP	DX
		POP	AX
		CLC
		RET

;
; QoCgo
;
; PARAM.: AX	o̓f[^
;	  DX	h^n|[g
; RESULT: CY
;	  AX	̓f[^
;
SEND_WORD:
		XCHG	AH,AL
		CALL	SEND_RECE
		JC	@@CANCEL
		XCHG	AH,AL
		CALL	SEND_RECE
@@CANCEL:
		RET

;
; SoCgo
;
; PARAM.: BX:AX	o̓f[^
;	  DX	h^n|[g
; RESULT: CY
;
SEND_LONG:
		PUSH	AX
		MOV	AX,BX
		CALL	SEND_WORD
		POP	AX
		JC	@@CANCEL
		CALL	SEND_WORD
@@CANCEL:
		RET

;
; bZ[W\
;
; PARAM.: DX	bZ[W
;
PRINT:
		MOV	AH,09H
		INT	21H
		RET

;
; G[
;
; PARAM.: DX	G[bZ[W
;
ERROR:
		CALL	PRINT
		MOV	AX,4C01H
		INT	21H

;
; f[^GA
;
WAIT_KEY	DB	0
PORT_ENV	DB	'PORT',0
PORT		DB	02h
ADRS		DW	2000h,0600h

;
; bZ[W
;
		DB	13,10
TITLE_MSG	DB	'SSFEXE.COM version1.00 (c)1997 ohD',13,10
		DB	'$'
USAGE_MSG	DB	'Usage:SSFEXE [options] filename',13,10
		DB	'SS-PARփvO]As܂',13,10
		DB	'options:',13,10
		DB	'    -p<x>   |[gw (0:300,1:310,2:320,3:330 def=2)',13,10
		DB	'    -k      sOɃ|[Y',13,10
		DB	'    -l<addr>AhXw (def=06002000)',13,10
		DB	'$'
ERROR_MSG	DB	'SS-PARƂ̒ʐMɎs܂',13,10
		DB	'$'
MEMORY_MSG	DB	'sĂ܂',13,10
		DB	'$'
FILEERR_MSG	DB	't@C֌W̃G[܂',13,10
		DB	'$'
PAUSE_MSG	DB	'L[Ǝs܂',13,10
		DB	'$'
CONNECT_MSG	DB	'SS-PARƂ̐ڑmFĂ܂',13,10
		DB	'$'
DATA_MSG	DB	'f[^]ł',13,10
		DB	'$'
ENVERR_MSG	DB	'ϐւ̐ݒlُł',13,10
		DB	'$'
		ifdef	DEBUG
FILE_MSG	DB	'EXECUTE FILE :'
		DB	'$'
PORT_MSG	DB	'LINK I/O PORT:3x0h',13,10
		DB	'$'
ADRS_MSG	DB	'START ADDRESS:00000000h',13,10
		DB	'$'
		endif

;
; arr
;
CHKSUM		DW	?
FILELEN		DW	2 DUP (?)
FILEH		DW	?
FILENAME	DB	128 DUP (?)

;
; vOI
;
PROG_END:
		END	START
