//
// SSFEXE.EXE
// SEGA SATURN File Executor
//
// Copyright (C) 1997-1998 ohD
// for SATURN ProActionReplay and X-TERMINATOR
// ̃vÓAVisual C++ 4.0 (Standard Edition) ō쐬܂B
//

#include <afxwin.h>
#include <afxext.h>
#include <afxcmn.h>
#include "SSFEXE.h"

//
// O[oϐ
//
char szRegVendor[] = "PI";
char szRegSection[] = "Config";
char szRegPort[] = "PortNo";
char szRegRecents[] = "RecentFiles";
char szRegRecent[] = "RecentFile%d";
char szRegARecents[] = "RecentAdrss";
char szRegARecent[] = "RecentAdrs%d";
UINT m_flagport;					// tO|[g
UINT m_dataport;					// f[^|[g

//
//
// AvP[VNX
//
//
CApp theApp;

//
// CApp()
// RXgN^
//
CApp::CApp() : CWinApp()
{
}

//
// InitInstance()
// AvP[V
//
BOOL CApp::InitInstance()
{
	// RcRg[
	#ifdef _AFXDLL
		Enable3dControls();
	#else
		Enable3dControlsStatic();
	#endif

	// WXgL[ݒ(protected̂)
	SetRegistryKey(szRegVendor);

	// _CAOs
	CMainDlg dlg;
	m_pMainWnd = &dlg;
	dlg.DoModal();

	// I
	return FALSE;
}

//-----------------------------------------------------------------------------

//
//
// _CAONX
//
//
BEGIN_MESSAGE_MAP(CMainDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_COMMAND(IDC_BROWSE, OnBrowse)
	ON_COMMAND(IDC_EXECUTE, OnExecute)
	ON_COMMAND(IDCANCEL, OnCancel)
END_MESSAGE_MAP()

//
// CMainDlg()
// RXgN^
//
CMainDlg::CMainDlg(CWnd* pParent) : CDialog(IDD_MAINDLG, pParent)
{
}

//
// OnInitDialog()
// _CAO
//
BOOL CMainDlg::OnInitDialog()
{
	HICON hIcon;
	CMenu *pSysMenu;
	CString strMru;
	UINT i;
	
	// {NX
	CDialog::OnInitDialog();

	// ACR
	hIcon = AfxGetApp()->LoadIcon(IDI_SSFEXE);
	SetIcon(hIcon, TRUE);
	SetIcon(hIcon, FALSE);

	// "o[W..." j[ǉ
	ASSERT((IDM_ABOUT & 0xfff0) == IDM_ABOUT);
	ASSERT(IDM_ABOUT < 0xf000);
	// j[ǉnj
	pSysMenu = GetSystemMenu(FALSE);
	CString strAbout;
	strAbout.LoadString(IDS_ABOUT);
	pSysMenu->AppendMenu(MF_SEPARATOR);
	pSysMenu->AppendMenu(MF_STRING, IDM_ABOUT, strAbout);

	// hLgif[^oj
	m_fname = CString("");

	// WXgǂݍ݁
	m_port   = AfxGetApp()->GetProfileInt(szRegSection, szRegPort, 1);
	m_mrunum = AfxGetApp()->GetProfileInt(szRegSection, szRegRecents, 0);
	for (i=0; i<m_mrunum; i++) {
		strMru.Format(szRegRecent, i);
		m_fnmru[i] = AfxGetApp()->GetProfileString(szRegSection, strMru, "");
	}
	m_adrsnum = AfxGetApp()->GetProfileInt(szRegSection, szRegARecents, 0);
	for (i=0; i<m_adrsnum; i++) {
		strMru.Format(szRegARecent, i);
		m_adrsmru[i] = AfxGetApp()->GetProfileString(szRegSection, strMru, "");
	}

	// |[gԍR{{bNX
	CComboBox *pComboBox = (CComboBox*)GetDlgItem(IDC_PCOMBO);
	pComboBox->SetCurSel(m_port);

	// t@CR{{bNX
	if (m_mrunum > 0) {
		pComboBox = (CComboBox*)GetDlgItem(IDC_FNCOMBO);
		for (i=0; i<m_mrunum; i++)
			pComboBox->InsertString(i, m_fnmru[i]);
		pComboBox->SetWindowText(m_fnmru[0]);
	}

	// AhXR{{bNX
	if (m_adrsnum > 0) {
		pComboBox = (CComboBox*)GetDlgItem(IDC_ADRSCOMBO);
		for (i=0; i<m_adrsnum; i++)
			pComboBox->InsertString(i, m_adrsmru[i]);
		pComboBox->SetWindowText(m_adrsmru[0]);
	}

	// vOX o[
	CProgressCtrl *pProgressCtrl;
	pProgressCtrl = (CProgressCtrl*)GetDlgItem(IDC_PROGRESS);
	pProgressCtrl->SetRange(0, 100);

	// qd`cx
	ExecEnd();

	return TRUE;
}

//
// OnSysCommand()
// About
//
void CMainDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xfff0) == IDM_ABOUT) {
		CAboutDlg dlg;
		dlg.DoModal();
	}
	else
		CDialog::OnSysCommand(nID, lParam);
}

//
// OnBrowse()
// Q(B)
//
void CMainDlg::OnBrowse()
{
	CString strFilter;
	LPCTSTR szFilter;

	strFilter.LoadString(IDS_FILTER);
	szFilter = strFilter;

	// R_CAO{bNXs	
	CFileDialog dlg(TRUE, NULL, NULL, OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, szFilter);
	if (dlg.DoModal() == IDOK) {
		// GfBbg{bNXփRs[
		CComboBox* pComboBox = (CComboBox*)GetDlgItem(IDC_FNCOMBO);
		pComboBox->SetWindowText(dlg.GetPathName());
	}
}

//
// OnCancel()
// LZ
//
void CMainDlg::OnCancel()
{
	UINT i;
	CString strMru;

	// s肵āAtOĂ
	if (m_exec) {
		m_abort = TRUE;
		return;
	}

	// WXg
	AfxGetApp()->WriteProfileInt(szRegSection, szRegPort, m_port);
	AfxGetApp()->WriteProfileInt(szRegSection, szRegRecents, m_mrunum);
	for (i=0; i<m_mrunum; i++) {
		strMru.Format(szRegRecent, i);
		AfxGetApp()->WriteProfileString(szRegSection, strMru, m_fnmru[i]);
	}
	AfxGetApp()->WriteProfileInt(szRegSection, szRegARecents, m_adrsnum);
	for (i=0; i<m_adrsnum; i++) {
		strMru.Format(szRegARecent, i);
		AfxGetApp()->WriteProfileString(szRegSection, strMru, m_adrsmru[i]);
	}

	// LZŃ_CAO
	EndDialog(IDCANCEL);
}

//
// OnExecute()
// s(X)
//
void CMainDlg::OnExecute()
{
	CString fname;
	CString stradrs;
	CComboBox *pComboBox;
	UINT sum;
	CFile file;

	ASSERT(m_exec != TRUE);

	// t@C͂Ă邩ׂ
	pComboBox = (CComboBox*)GetDlgItem(IDC_FNCOMBO);
	pComboBox->GetWindowText(fname);
	if (fname.GetLength() == 0) {
		CString strNoFname;
		strNoFname.LoadString(IDS_NOFNAME);
		MessageBox(strNoFname, NULL, MB_ICONSTOP | MB_OK);
		return;
	}

	// t@C݂邩ׂ
	if (!file.Open(fname, CFile::modeRead)) {
		CString strOpErr;
		strOpErr.LoadString(IDS_OPENERR);
		MessageBox(strOpErr, NULL, MB_ICONSTOP | MB_OK);
		return;
	}
	// t@Cl[
	m_fname = fname;

	// AhX͂Ă邩ׂ
	pComboBox = (CComboBox*)GetDlgItem(IDC_ADRSCOMBO);
	pComboBox->GetWindowText(stradrs);
	if (stradrs.GetLength() == 0) {
		CString strNoAdrs;
		strNoAdrs.LoadString(IDS_NOADRS);
		MessageBox(strNoAdrs, NULL, MB_ICONSTOP | MB_OK);
		return;
	}

	// AhX߁iG[Ȃj
	m_adrs = strtoul(stradrs, NULL, 16);
	stradrs.Format("%08x", m_adrs);
	pComboBox->SetWindowText(stradrs);

	// |[gio[M
	pComboBox = (CComboBox*)GetDlgItem(IDC_PCOMBO);
	m_port = pComboBox->GetCurSel();
	m_flagport = m_port * 0x10 + 0x302;
	m_dataport = m_port * 0x10 + 0x300;

	// lqt
	ProcessfMRU(fname);
	ProcessaMRU(stradrs);

	// ʁEtOXV
	ExecStart();

	// ҂
	Reply();
	if (!m_abort)
		Info(file);
		if (!m_abort)
			sum = SendMain(file);
			if (!m_abort)
				ChkSum(sum);

	// I
	file.Close();
	ExecEnd();
}

//
// Status()
// Xe[^XeLXgEvOX
//
void CMainDlg::Status(UINT nID, UINT num)
{
	CStatic *pStatic;
	CString strStatus;
	CProgressCtrl *pProgressCtrl;

	strStatus.LoadString(nID);
	pStatic = (CStatic*)GetDlgItem(IDC_PROGL);
	pStatic->SetWindowText(strStatus);

	pProgressCtrl = (CProgressCtrl*)GetDlgItem(IDC_PROGRESS);
	pProgressCtrl->SetPos(num);
}

//
// ExecStart()
// thEtOXV
//
void CMainDlg::ExecStart()
{
	CComboBox *pComboBox;
	CButton *pButton;
	CString strButton;

	strButton.LoadString(IDS_BSTOP);

	m_exec = TRUE;
	m_abort = FALSE;

	Status(IDS_INIT, 10);

	pButton = (CButton*)GetDlgItem(IDC_EXECUTE);
	pButton->EnableWindow(FALSE);
	pButton = (CButton*)GetDlgItem(IDCANCEL);
	pButton->SetWindowText(strButton);
	pButton = (CButton*)GetDlgItem(IDC_BROWSE);
	pButton->EnableWindow(FALSE);
	pComboBox = (CComboBox*)GetDlgItem(IDC_PCOMBO);
	pComboBox->EnableWindow(FALSE);
	pComboBox = (CComboBox*)GetDlgItem(IDC_FNCOMBO);
	pComboBox->EnableWindow(FALSE);
	pComboBox = (CComboBox*)GetDlgItem(IDC_ADRSCOMBO);
	pComboBox->EnableWindow(FALSE);
	
	strButton.LoadString(IDS_CAPTION);
	strButton += " - ";
	strButton += m_fname;
	SetWindowText(strButton);
}

//
// ExecEnd()
// thEtOXV
//
void CMainDlg::ExecEnd()
{
	CComboBox *pComboBox;
	CButton *pButton;
	CString strButton;

	strButton.LoadString(IDS_CAPTION);
	SetWindowText(strButton);

	strButton.LoadString(IDS_BCLOSE);

	m_exec = FALSE;
	m_abort = FALSE;

	Status(IDS_READY, 0);

	pButton = (CButton*)GetDlgItem(IDC_EXECUTE);
	pButton->EnableWindow(TRUE);
	pButton = (CButton*)GetDlgItem(IDCANCEL);
	pButton->SetWindowText(strButton);
	pButton = (CButton*)GetDlgItem(IDC_BROWSE);
	pButton->EnableWindow(TRUE);
	pComboBox = (CComboBox*)GetDlgItem(IDC_PCOMBO);
	pComboBox->EnableWindow(TRUE);
	pComboBox = (CComboBox*)GetDlgItem(IDC_FNCOMBO);
	pComboBox->EnableWindow(TRUE);
	pComboBox = (CComboBox*)GetDlgItem(IDC_ADRSCOMBO);
	pComboBox->EnableWindow(TRUE);
}

//
// ProcessMRU()
// t@ClqtAǉA\[g
//
void CMainDlg::ProcessfMRU(CString& fname)
{
	UINT i, idx;
	CComboBox* pComboBox;

	// R{{bNX̐|C^擾
	pComboBox = (CComboBox*)GetDlgItem(IDC_FNCOMBO);

	// ͂߂Ēǉ
	if (m_mrunum == 0) {
		// Pǉ
		m_mrunum++;
		m_fnmru[0] = fname;
		pComboBox->AddString(fname);
		return;
	}
	else {
		idx = pComboBox->FindStringExact(0, fname);

		// ɂPȏ゠AVKǉ
		if (idx == CB_ERR) {
			// Ȃ̂ŁA܂m_mrunum𑝂₷
			if (m_mrunum < 16)
					m_mrunum++;
			else
				pComboBox->DeleteString(15);
			// PÂ
			for (i=(m_mrunum-1); i>0; i--)
					m_fnmru[i] = m_fnmru[i-1];
			// ԑOɑ}
			pComboBox->InsertString(0, fname);
			m_fnmru[0] = fname;
			return;
		}	
		// ɓo^ς
		else {
			// ɂ炷
			for (i=idx; i>0; i--)
				m_fnmru[i] = m_fnmru[i-1];
			// 
			m_fnmru[0] = fname;
			// NA
			pComboBox->ResetContent();
			// ǉ
			for (i=0; i<m_mrunum; i++)
				pComboBox->AddString(m_fnmru[i]);
			// GfBbg
			pComboBox->SetWindowText(fname);
			return;
		}
	}
}

//
// ProcessaMRU()
// AhXlqtAǉA\[g
//
void CMainDlg::ProcessaMRU(CString& sadrs)
{
	UINT i, idx;
	CComboBox* pComboBox;

	// R{{bNX̐|C^擾
	pComboBox = (CComboBox*)GetDlgItem(IDC_ADRSCOMBO);

	// ͂߂Ēǉ
	if (m_adrsnum == 0) {
		// Pǉ
		m_adrsnum++;
		m_adrsmru[0] = sadrs;
		pComboBox->AddString(sadrs);
		return;
	}
	else {
		idx = pComboBox->FindStringExact(0, sadrs);

		// ɂPȏ゠AVKǉ
		if (idx == CB_ERR) {
			// Ȃ̂ŁA܂m_adrsnum𑝂₷
			if (m_adrsnum < 16)
					m_adrsnum++;
			else
				pComboBox->DeleteString(15);
			// PÂ
			for (i=(m_adrsnum-1); i>0; i--)
					m_adrsmru[i] = m_adrsmru[i-1];
			// ԑOɑ}
			pComboBox->InsertString(0, sadrs);
			m_adrsmru[0] = sadrs;
			return;
		}	
		// ɓo^ς
		else {
			// ɂ炷
			for (i=idx; i>0; i--)
				m_adrsmru[i] = m_adrsmru[i-1];
			// 
			m_adrsmru[0] = sadrs;
			// NA
			pComboBox->ResetContent();
			// ǉ
			for (i=0; i<m_adrsnum; i++)
				pComboBox->AddString(m_adrsmru[i]);
			// GfBbg
			pComboBox->SetWindowText(sadrs);
			return;
		}
	}
}

//-----------------------------------------------------------------------------

//
//
// About_CAONX
//
//
BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	ON_WM_PAINT()
END_MESSAGE_MAP()


//
// CAboutDlg()
// RXgN^
//
CAboutDlg::CAboutDlg(CWnd* pParent) : CDialog(IDD_ABOUTDLG, pParent)
{
}

//
// OnInitDialog()
// t[p
//
BOOL CAboutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	CStatic* pStatic = (CStatic*)GetDlgItem(IDC_ADLGICON);
	pStatic->GetWindowRect(&m_rect);
	pStatic->DestroyWindow();
	ScreenToClient(&m_rect);

	return TRUE;
}

//
// OnPaint()
// ACR`p
//
void CAboutDlg::OnPaint()
{
	// cbAACRnh擾
	CPaintDC dc(this);
	HICON hIcon = AfxGetMainWnd()->GetIcon(TRUE);

	if (hIcon != NULL) {
		// cbArbg}bv쐬
		CDC dcMem;
		dcMem.CreateCompatibleDC(&dc);
		CBitmap bitmap;
		bitmap.CreateCompatibleBitmap(&dc, 32, 32);

		// rbg}bvփACR`
		CBitmap* pOldBitmap = dcMem.SelectObject(&bitmap);
		CBrush brush(::GetSysColor(COLOR_3DFACE));
		dcMem.FillRect(CRect(0, 0, 32, 32), &brush);
		dcMem.DrawIcon(0, 0, hIcon);

		// ]
		dc.StretchBlt(m_rect.left, m_rect.top, m_rect.Width(),
						m_rect.Height(), &dcMem, 0, 0, 32, 32, SRCCOPY);
		dcMem.SelectObject(pOldBitmap);
	}
}

//-----------------------------------------------------------------------------

//
// Inport()
// h^n|[g
//
UINT CMainDlg::Inport(UINT port)
{
	UINT result;

	__asm {
		mov	edx,port
		xor	eax,eax
		in	al,dx
		mov	result,eax
	}

	return result;
}

//
// Outport()
// h^n|[go
//
void CMainDlg::Outport(UINT port, UINT data)
{
	__asm {
		mov	edx,port
		mov	eax,data
		out	dx,al
	}
}

//
// BusyChk()
// ~vBUSY`FbN
//
void CMainDlg::BusyChk()
{
	MSG msg;

	// |[g
	while (Inport(m_flagport) & 0x01) {

		// bZ[W |v
		while (::PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE)) {
			if (!AfxGetApp()->PumpMessage()) {
				::PostQuitMessage(0);
				return;
			}
		}
		LONG lIdle = 0;
		while (AfxGetApp()->OnIdle(lIdle++))
			;

		// tO`FbN
		if (m_abort)
			return;
	}
}

//
// MM
//
UINT CMainDlg::SendRece(UINT sdata)
{
	UINT result;

	// 
	__asm {
		mov	edx,m_dataport
		mov	eax,sdata
		out	dx,al

		xor	eax,eax
		mov	edx,m_flagport
		in	al,dx
		and	al,01h
		mov	result,eax
	}

	// atrx`FbN
	if (result) {
		BusyChk();
		if (m_abort)
			return (UINT)NULL;
	}

	// 
	__asm {
		xor	eax,eax
		mov	edx,m_dataport
		in	al,dx
		mov	result,eax
	}

	return result;
}

//
// QoCgM
//
UINT CMainDlg::SendWord(UINT wdata)
{
	UINT rdata;

	rdata = SendRece(wdata >> 8) * 256;
	if (m_abort)
		return (UINT)NULL;

	rdata += SendRece(wdata & 255);
	return rdata;
}

//
// SoCgM
//
void CMainDlg::SendLong(UINT ldata)
{
	SendRece(ldata >> 24);
	if (m_abort)
		return;
	SendRece((ldata >> 16) & 255);
	if (m_abort)
		return;
	SendRece((ldata >> 8) & 255);
	if (m_abort)
		return;
	SendRece(ldata & 255);
}

//-----------------------------------------------------------------------------

//
// T^[̉҂
//
void CMainDlg::Reply()
{
	UINT res;

	Status(IDS_REPLY, 20);


	for (;;) {
		res = SendRece('W');
		if (m_abort)
			return;
		if (res != 'R')
			continue;

		res = SendRece('B');
		if (m_abort)
			return;
		if (res == 'W')
			break;
	}

	SendRece('X');
}

//
// 񑗐M
//
void CMainDlg::Info(CFile& file)
{
	Status(IDS_INFO, 30);

	SendLong(m_adrs);
	if (m_abort)
		return;

	SendLong(file.GetLength());
}

//
// t@CM
//
UINT CMainDlg::SendMain(CFile& file)
{
	UINT flen, i, j, k;
	UINT sum;
	char *buf;

	Status(IDS_SEND, 40);
	sum = 0;

	flen = file.GetLength();

	if (flen < 10) {
		buf = (char *)malloc(flen);
		file.Read(buf, flen);
		// POoCgȉ
		for (i=0; i<flen; i++) {
			sum += SendRece(buf[i]);
		}
		if (m_abort) {
			free(buf);
			return (UINT)NULL;
		}
		free(buf);
		return sum;
	}
	else {
		// PO
		j = flen / 10;
		buf = (char *)malloc(j);
		
		for (i=0; i<10; i++) {
			Status(IDS_SEND, i*5 + 40);
			file.Read(buf, j);
			for (k=0; k<j; k++) {
				sum += SendRece(buf[k]);
			}
			if (m_abort) {
				free(buf);
				return (UINT)NULL;
			}
		}
		// ]
		file.Read(buf, flen % 10);
		for (k=0; k<(flen % 10); k++) {
			sum += SendRece(buf[k]);
		}
		if (m_abort) {
			free(buf);
			return (UINT)NULL;
		}
		free(buf);
		return sum;
	}
}

//
// `FbNTƍ
//
void CMainDlg::ChkSum(UINT sum)
{
	UINT res;

	Status(IDS_CHKSUM, 95);
	sum &= 0x0fff;
	res = SendWord(sum);

	sum &= 0x0f00;
	res &= 0x0f00;

	if (m_abort)
		return;

	if (sum != res) {
		CString strErr;
		strErr.LoadString(IDS_SUMERR);
		MessageBox(strErr, NULL, MB_ICONSTOP | MB_OK);
	}

	return;
}
