//
// SSFEXE.EXE
// SEGA SATURN File Executor
//
// Copyright (C) 1997-1998 ohD
// for SATURN ProActionReplay and X-TERMINATOR
// ̃vÓAVisual C++ 4.0 (Standard Edition) ō쐬܂B
//

#include "resource.h"

//
// AvP[VNX
//
class CApp : public CWinApp
{
public:
	CApp();								// RXgN^
	virtual BOOL InitInstance();		// AvP[V
};

//
// _CAONX
//
class CMainDlg : public CDialog
{
public:
	CMainDlg(CWnd* pParent = NULL);		// RXgN^
	virtual BOOL OnInitDialog();		// _CAO

	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
										// VXeR}h (About_CAO)
	afx_msg void OnBrowse();			// Q
	afx_msg void OnExecute();			// s
	afx_msg void OnCancel();			// LZ

private:
	UINT m_port;						// |[gԍ(0`3)
	CString m_fname;					// st@C
	CString m_fnmru[16];				// st@C(MRU)
	UINT m_mrunum;						// LMRU(0`16)
	UINT m_adrs;						// sAhX
	CString m_adrsmru[16];				// sAhX(MRU)
	UINT m_adrsnum;						// LMRU(0`16)
	BOOL m_exec;						// stO
	BOOL m_abort;						// ~tO

	void ProcessfMRU(CString& fname);	// MRU
	void ProcessaMRU(CString& sadrs);	// MRU
	void Status(UINT nID, UINT num);
	void ExecStart();					// sJnUIXV
	void ExecEnd();						// READYUIXV

	UINT Inport(UINT port);				// inp()
	void Outport(UINT port, UINT data);	// outp()
	void BusyChk();						// BUSY`FbN+bZ[W|v
	UINT SendRece(UINT sdata);			// PoCgM
	UINT SendWord(UINT wdata);			// QoCgM
	void SendLong(UINT ldata);			// SoCgM

	void Reply();						// T^[҂
	void Info(CFile& file);				// 񑗐M
	UINT SendMain(CFile& file);			// Cf[^M
	void ChkSum(UINT sum);				// `FbNT

	DECLARE_MESSAGE_MAP()				// bZ[W }bv
};

//
// About_CAONX
//
class CAboutDlg : public CDialog
{
public:
	CAboutDlg(CWnd* pParent = NULL);	// RXgN^
	virtual BOOL OnInitDialog();		// _CAO
	afx_msg void OnPaint();				// WM_PAINT

private:
	CRect m_rect;						// ACR

	DECLARE_MESSAGE_MAP()				// bZ[W }bv
};

